// AppearanceProp.h : Declaration of the CAppearanceProp

#ifndef __APPEARANCEPROP_H_
#define __APPEARANCEPROP_H_

#include "resource.h"       // main symbols
#include <commctrl.h>

EXTERN_C const CLSID CLSID_AppearanceProp;

/////////////////////////////////////////////////////////////////////////////
// CAppearanceProp
class ATL_NO_VTABLE CAppearanceProp :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAppearanceProp, &CLSID_AppearanceProp>,
	public IPropertyPageImpl<CAppearanceProp>,
	public CDialogImpl<CAppearanceProp>
{
public:
	CAppearanceProp() 
	{
		m_dwTitleID = IDS_TITLEAppearanceProp;
		m_dwHelpFileID = IDS_HELPFILEAppearanceProp;
		m_dwDocStringID = IDS_DOCSTRINGAppearanceProp;
	}

	enum {IDD = IDD_APPEARANCEPROP};

	HWND m_hBorderWidthEdit;
	HWND m_hBorderWidthSpin;
	HWND m_hAppearanceCombo;
	HWND m_hFillStyleCombo;
	HWND m_hEnableCheck;
	HWND m_hBorderVisibleCheck;
	HWND m_hTabStopCheck;
	HWND m_hFillPatternCombo;
	HWND m_hDrawStyleCombo;

	long m_nDrawStyle;

DECLARE_REGISTRY_RESOURCEID(IDR_APPEARANCEPROP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAppearanceProp) 
	COM_INTERFACE_ENTRY(IPropertyPage)
END_COM_MAP()

BEGIN_MSG_MAP(CAppearanceProp)
	CHAIN_MSG_MAP(IPropertyPageImpl<CAppearanceProp>)
	COMMAND_HANDLER(IDC_APPEARANCE_COMBO, CBN_SELCHANGE, OnSelchangeAppearance_combo)
	COMMAND_HANDLER(IDC_BORDERVISIBLE_CHECK, BN_CLICKED, OnClickedBordervisible_check)
	COMMAND_HANDLER(IDC_BORDERWIDTH_EDIT, EN_CHANGE, OnChangeBorderwidth_edit)
	NOTIFY_HANDLER(IDC_BORDERWIDTH_SPIN, UDN_DELTAPOS, OnDeltaposBorderwidth_spin)
	COMMAND_HANDLER(IDC_DRAWSTYLE_COMBO, CBN_SELCHANGE, OnSelchangeDrawstyle_combo)
	COMMAND_HANDLER(IDC_ENABLE_CHECK, BN_CLICKED, OnClickedEnable_check)
	COMMAND_HANDLER(IDC_FILLSTYLE_COMBO, CBN_SELCHANGE, OnSelchangeFillstyle_combo)
	COMMAND_HANDLER(IDC_PATTERN_COMBO, CBN_SELCHANGE, OnSelchangePattern_combo)
	COMMAND_HANDLER(IDC_TABSTOP_CHECK, BN_CLICKED, OnClickedTabstop_check)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	STDMETHOD(Apply)(void);
	LRESULT OnSelchangeAppearance_combo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedBordervisible_check(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnChangeBorderwidth_edit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnDeltaposBorderwidth_spin(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	LRESULT OnSelchangeDrawstyle_combo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedEnable_check(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnSelchangeFillstyle_combo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnSelchangePattern_combo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedTabstop_check(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

private:
	void HandleError ();
};

#endif //__APPEARANCEPROP_H_
